Bullet Collision Detection & Physics Library: btConeShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Private Member Functions | Private Attributes | List of all members
btConeShape Class Reference

The btConeShape implements a cone shape primitive, centered around the origin and aligned with the Y axis. The btConeShapeX is aligned around the X axis and btConeShapeZ around the Z axis. More...

`#include <btConeShape.h>`

Inheritance diagram for btConeShape:
[legend]
Collaboration diagram for btConeShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConeShape (btScalar radius, btScalar height)
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
btScalar | getRadius () const
btScalar | getHeight () const
void | setRadius (const btScalar radius)
void | setHeight (const btScalar height)
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
virtual const char * | getName () const
void | setConeUpIndex (int upIndex)
| choose upAxis index
int | getConeUpIndex () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example
virtual void | setLocalScaling (const btVector3 &scaling)
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
Public Member Functions inherited from btConvexInternalShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btConvexInternalShape ()
const btVector3 & | getImplicitShapeDimensions () const
void | setImplicitShapeDimensions (const btVector3 &dimensions)
| warning: use setImplicitShapeDimensions with care changing a collision shape while the body is in the world is not recommended, it is best to remove the body from the world, then make the change, and re-add it alternatively flush the contact points, see documentation for 'cleanProxyFromPairs'
void | setSafeMargin (btScalar minDimension, btScalar defaultMarginMultiplier=0.1f)
void | setSafeMargin (const btVector3 &halfExtents, btScalar defaultMarginMultiplier=0.1f)
void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual const btVector3 & | getLocalScaling () const
const btVector3 & | getLocalScalingNV () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
btScalar | getMarginNV () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3
virtual | ~btConvexShape ()
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations.
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check)
int | getShapeType () const
void | setUserPointer (void *userPtr)
| optional user data pointer
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
void | setUserIndex2 (int index)
int | getUserIndex2 () const
virtual void | serializeSingleShape (btSerializer *serializer) const

## Private Member Functions
btVector3 | coneLocalSupport (const btVector3 &v) const

## Private Attributes
btScalar | m_sinAngle
btScalar | m_radius
btScalar | m_height
int | m_coneIndices [3]

## Additional Inherited Members
Protected Member Functions inherited from btConvexInternalShape
| btConvexInternalShape ()
Protected Attributes inherited from btConvexInternalShape
btVector3 | m_localScaling
btVector3 | m_implicitShapeDimensions
btScalar | m_collisionMargin
btScalar | m_padding
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex
int | m_userIndex2

## Detailed Description

The btConeShape implements a cone shape primitive, centered around the origin and aligned with the Y axis. The btConeShapeX is aligned around the X axis and btConeShapeZ around the Z axis.

Definition at line 23 of file btConeShape.h.

## Constructor & Destructor Documentation

## ◆ btConeShape()

btConeShape::btConeShape | ( | btScalar | radius,
|  | btScalar | height )

Definition at line 18 of file btConeShape.cpp.

## Member Function Documentation

## ◆ batchedUnitVectorGetSupportingVertexWithoutMargin()

void btConeShape::batchedUnitVectorGetSupportingVertexWithoutMargin | ( | const btVector3 * | vectors,
|  | btVector3 * | supportVerticesOut,
|  | int | numVectors ) const
| virtual

Implements btConvexShape.

Definition at line 108 of file btConeShape.cpp.

## ◆ BT_DECLARE_ALIGNED_ALLOCATOR()

btConeShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## ◆ calculateLocalInertia()

virtual void btConeShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia ) const
| inlinevirtual

Implements btCollisionShape.

Definition at line 54 of file btConeShape.h.

## ◆ calculateSerializeBufferSize()

int btConeShape::calculateSerializeBufferSize | ( |  | ) | const
| inlinevirtual

Reimplemented from btConvexInternalShape.

Definition at line 152 of file btConeShape.h.

## ◆ coneLocalSupport()

btVector3 btConeShape::coneLocalSupport | ( | const btVector3 & | v | ) | const
| private

Definition at line 67 of file btConeShape.cpp.

## ◆ getAnisotropicRollingFrictionDirection()

virtual btVector3 btConeShape::getAnisotropicRollingFrictionDirection | ( |  | ) | const
| inlinevirtual

the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example

Reimplemented from btCollisionShape.

Reimplemented in btConeShapeX, and btConeShapeZ.

Definition at line 93 of file btConeShape.h.

## ◆ getConeUpIndex()

int btConeShape::getConeUpIndex | ( |  | ) | const
| inline

Definition at line 88 of file btConeShape.h.

## ◆ getHeight()

btScalar btConeShape::getHeight | ( |  | ) | const
| inline

Definition at line 43 of file btConeShape.h.

## ◆ getName()

virtual const char * btConeShape::getName | ( |  | ) | const
| inlinevirtual

Implements btCollisionShape.

Reimplemented in btConeShapeX, and btConeShapeZ.

Definition at line 80 of file btConeShape.h.

## ◆ getRadius()

btScalar btConeShape::getRadius | ( |  | ) | const
| inline

Definition at line 42 of file btConeShape.h.

## ◆ localGetSupportingVertex()

btVector3 btConeShape::localGetSupportingVertex | ( | const btVector3 & | vec | ) | const
| virtual

Reimplemented from btConvexInternalShape.

Definition at line 117 of file btConeShape.cpp.

## ◆ localGetSupportingVertexWithoutMargin()

btVector3 btConeShape::localGetSupportingVertexWithoutMargin | ( | const btVector3 & | vec | ) | const
| virtual

Implements btConvexShape.

Definition at line 103 of file btConeShape.cpp.

## ◆ serialize()

const char * btConeShape::serialize | ( | void * | dataBuffer,
|  | btSerializer * | serializer ) const
| inlinevirtual

fills the dataBuffer and returns the struct name (and 0 on failure)

Reimplemented from btConvexInternalShape.

Definition at line 158 of file btConeShape.h.

## ◆ setConeUpIndex()

void btConeShape::setConeUpIndex | ( | int | upIndex | ) |

choose upAxis index

Definition at line 39 of file btConeShape.cpp.

## ◆ setHeight()

void btConeShape::setHeight | ( | const btScalar | height | ) |
| inline

Definition at line 49 of file btConeShape.h.

## ◆ setLocalScaling()

void btConeShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| virtual

Reimplemented from btConvexInternalShape.

Definition at line 133 of file btConeShape.cpp.

## ◆ setRadius()

void btConeShape::setRadius | ( | const btScalar | radius | ) |
| inline

Definition at line 45 of file btConeShape.h.

## Member Data Documentation

## ◆ m_coneIndices

int btConeShape::m_coneIndices[3]
| private

Definition at line 30 of file btConeShape.h.

## ◆ m_height

btScalar btConeShape::m_height
| private

Definition at line 29 of file btConeShape.h.

## ◆ m_radius

btScalar btConeShape::m_radius
| private

Definition at line 28 of file btConeShape.h.

## ◆ m_sinAngle

btScalar btConeShape::m_sinAngle
| private

Definition at line 27 of file btConeShape.h.

The documentation for this class was generated from the following files:

- btConeShape.h
- btConeShape.cpp